# Python N Queens Solution

The Python solution to the N Queens problem 
is contained in `nqueens.py`. This code uses zero modules 
and has zero import statements. 

This code can be timed or profiled by wrapping this code
in other code that starts the timer or the profiler,
and that is what `pycprof_nqueens.py` and `time_nqueens.py` do.

We'll get to that in a sec.

## Running

To run this code, no compilation necessary:

```plain
$ python nqueens.py
```

## Timing

To use Python to calculate the elapsed time 
during the solution of the N Queens problem,
use `time_nqueens.py`:

```plain
$ python time_nqueens.py
```

To time Python's solutions to N Queens problems
of various size, use the `time_python.sh` shell script:

```plain
$ ./time_python.sh
```


## Profiling

To use Python's built-in profiling tool `cProfile` 
to time Python, use the `pycprof_nqueens.py` program:

```plain
$ python pycprof_nqueens.py
```

To automate this process and profile the code for solving the 
N Queens problem for several values of N, use the 
`prof_python_cprof.sh` shell script:

```plain
$ ./prof_python_cprof.sh
```

To use the `line_profiler` module, which gives a line-by-line
breakdown of what amount of time was spent in what parts of the code,
install the `line_profiler` module, then run the program 
through `line_profiler`'s provided binary:

```plain
$ pip install line_profiler
$ kernprof -l nqueens.py
```

To automate this process and profile the code for 
several problem sizes, use the `prof_python_lineprof.sh` 
shell script:

```plain
$ ./prof_python_lineprof.sh
```